class nick.highscores.HighscoreEngine extends MovieClip
{
   static var __userName;
   static var __loadState;
   static var __xml;
   static var __userPath;
   static var __scorePath;
   static var __game_id;
   static var __user_vars;
   static var __userScore;
   static var __scores;
   static var __highscoreMC;
   static var __functionToRunAfterLoad;
   static var __stateVerificationInterval;
   static var __score_vars;
   static var __USE_XML = true;
   static var __XML_FILE_URL = "config.xml";
   static var __SCORE_CALL = "onHighscores";
   function HighscoreEngine()
   {
      super();
   }
   static function init()
   {
      trace("Highscore Data Class Initialized **");
      nick.highscores.HighscoreEngine.__userName = "null";
      nick.highscores.HighscoreEngine.__loadState = "loading";
      if(nick.highscores.HighscoreEngine.__USE_XML)
      {
         nick.highscores.HighscoreEngine.loadXML();
      }
   }
   static function loadXML()
   {
      nick.highscores.HighscoreEngine.__xml = new XML();
      nick.highscores.HighscoreEngine.__xml.ignoreWhite = true;
      nick.highscores.HighscoreEngine.__xml.onLoad = function(success)
      {
         nick.highscores.HighscoreEngine.onXMLloaded(success);
      };
      var _loc2_ = _root._url.slice(0,_root._url.lastIndexOf("/") + 1);
      if(_loc2_ != "")
      {
         _loc2_ += "/";
      }
      nick.highscores.HighscoreEngine.log("Loading XML file from " + (_loc2_ + nick.highscores.HighscoreEngine.__XML_FILE_URL) + " ...");
      nick.highscores.HighscoreEngine.__xml.load(_loc2_ + nick.highscores.HighscoreEngine.__XML_FILE_URL);
   }
   static function onXMLloaded(success)
   {
      if(success)
      {
         nick.highscores.HighscoreEngine.__userPath = nick.highscores.HighscoreEngine.__xml.firstChild.childNodes[0].firstChild.nodeValue;
         nick.highscores.HighscoreEngine.__scorePath = nick.highscores.HighscoreEngine.__xml.firstChild.childNodes[1].firstChild.nodeValue;
         nick.highscores.HighscoreEngine.__game_id = nick.highscores.HighscoreEngine.__xml.firstChild.childNodes[2].firstChild.nodeValue;
         nick.highscores.HighscoreEngine.log("Xml loaded : ");
         nick.highscores.HighscoreEngine.log("User : " + nick.highscores.HighscoreEngine.__userPath);
         nick.highscores.HighscoreEngine.log("score: " + nick.highscores.HighscoreEngine.__scorePath);
         nick.highscores.HighscoreEngine.log("gameID: " + nick.highscores.HighscoreEngine.__game_id);
      }
      else
      {
         nick.highscores.HighscoreEngine.log("XML Loading error");
      }
      nick.highscores.HighscoreEngine.updateUserLogin();
   }
   static function manualXML(userPath, scorePath, gameID)
   {
      nick.highscores.HighscoreEngine.__userPath = userPath;
      nick.highscores.HighscoreEngine.__scorePath = scorePath;
      nick.highscores.HighscoreEngine.__game_id = gameID;
      nick.highscores.HighscoreEngine.updateUserLogin();
   }
   static function updateUserLogin()
   {
      nick.highscores.HighscoreEngine.log("Test user login...");
      nick.highscores.HighscoreEngine.__user_vars = new LoadVars();
      nick.highscores.HighscoreEngine.__user_vars.onLoad = function(success)
      {
         nick.highscores.HighscoreEngine.onLogin(success);
      };
      nick.highscores.HighscoreEngine.__user_vars.load(nick.highscores.HighscoreEngine.__userPath);
   }
   static function onLogin(success)
   {
      if(success)
      {
         while(nick.highscores.HighscoreEngine.__user_vars.screenName.indexOf("/n") != -1)
         {
            nick.highscores.HighscoreEngine.log("Cull login string - : " + nick.highscores.HighscoreEngine.__user_vars.screenName);
            nick.highscores.HighscoreEngine.__user_vars.screenName = nick.highscores.HighscoreEngine.__user_vars.screenName.substr(0,nick.highscores.HighscoreEngine.__user_vars.screenName.length - 2);
            nick.highscores.HighscoreEngine.log("Result: " + nick.highscores.HighscoreEngine.__user_vars.screenName);
         }
         nick.highscores.HighscoreEngine.__userName = nick.highscores.HighscoreEngine.__user_vars.screenName;
         nick.highscores.HighscoreEngine.log("USER IS : " + nick.highscores.HighscoreEngine.__userName);
      }
      nick.highscores.HighscoreEngine.log("USER IS NOT LOGGED IN");
      nick.highscores.HighscoreEngine.__loadState = "ready";
   }
   static function populateHighscoreBoard()
   {
      if(nick.highscores.HighscoreEngine.isLoggedIn && nick.highscores.HighscoreEngine.__userScore > 0 && nick.highscores.HighscoreEngine.__userScore != undefined)
      {
         nick.highscores.HighscoreEngine.__highscoreMC.init(nick.highscores.HighscoreEngine.__scores,{name:nick.highscores.HighscoreEngine.__userName,score:nick.highscores.HighscoreEngine.__userScore});
      }
      else
      {
         nick.highscores.HighscoreEngine.__highscoreMC.init(nick.highscores.HighscoreEngine.__scores,{name:"",score:0});
      }
   }
   static function runReadyTest(callback)
   {
      if(nick.highscores.HighscoreEngine.__loadState != "ready")
      {
         nick.highscores.HighscoreEngine.__functionToRunAfterLoad = callback;
         nick.highscores.HighscoreEngine.startBoardReadyInterval();
         return false;
      }
      return true;
   }
   static function startBoardReadyInterval()
   {
      nick.highscores.HighscoreEngine.__stateVerificationInterval = setInterval(function()
      {
         nick.highscores.HighscoreEngine.runBoardReadyInterval();
      }
      ,5);
   }
   static function runBoardReadyInterval()
   {
      if(nick.highscores.HighscoreEngine.__loadState == "ready")
      {
         clearInterval(nick.highscores.HighscoreEngine.__stateVerificationInterval);
         if(nick.highscores.HighscoreEngine.__functionToRunAfterLoad == "sendAndView")
         {
            nick.highscores.HighscoreEngine.sendAndViewScore(nick.highscores.HighscoreEngine.__highscoreMC,nick.highscores.HighscoreEngine.__userScore);
         }
         else
         {
            nick.highscores.HighscoreEngine.viewScores(nick.highscores.HighscoreEngine.__highscoreMC);
         }
      }
      else if(nick.highscores.HighscoreEngine.__loadState == "error")
      {
         nick.highscores.HighscoreEngine.__highscoreMC.showError();
         clearInterval(nick.highscores.HighscoreEngine.__stateVerificationInterval);
      }
   }
   static function sendAndViewScore(boardMC, score)
   {
      nick.highscores.HighscoreEngine.__highscoreMC = boardMC;
      nick.highscores.HighscoreEngine.__userScore = score;
      nick.highscores.HighscoreEngine.__highscoreMC.gotoAndStop("loading");
      if(nick.highscores.HighscoreEngine.runReadyTest("sendAndView") == false)
      {
         return undefined;
      }
      nick.highscores.HighscoreEngine.log("Send Score...");
      if(nick.highscores.HighscoreEngine.__userName == "null" && nick.highscores.HighscoreEngine.__userName == undefined)
      {
         nick.highscores.HighscoreEngine.log("Error: User name is : " + nick.highscores.HighscoreEngine.__userName + ". Only logged in users may send scores.");
         return undefined;
      }
      nick.highscores.HighscoreEngine.__score_vars = new LoadVars();
      nick.highscores.HighscoreEngine.__score_vars.onLoad = function(success)
      {
         nick.highscores.HighscoreEngine.onHighscores(success);
      };
      nick.highscores.HighscoreEngine.log("Load ( " + nick.highscores.HighscoreEngine.__scorePath + "?msg=S&game=" + nick.highscores.HighscoreEngine.__game_id + "&name=" + nick.highscores.HighscoreEngine.__userName + "&score=" + score + "&limitEntries=true" + " )");
      nick.highscores.HighscoreEngine.__score_vars.load(nick.highscores.HighscoreEngine.__scorePath + "?msg=S&game=" + nick.highscores.HighscoreEngine.__game_id + "&name=" + nick.highscores.HighscoreEngine.__userName + "&score=" + score + "&limitEntries=true");
   }
   static function viewScores(boardMC)
   {
      nick.highscores.HighscoreEngine.__highscoreMC = boardMC;
      nick.highscores.HighscoreEngine.__userScore = 0;
      nick.highscores.HighscoreEngine.__highscoreMC.gotoAndStop("loading");
      if(nick.highscores.HighscoreEngine.runReadyTest("view") == false)
      {
         return undefined;
      }
      nick.highscores.HighscoreEngine.log("View Scores...");
      nick.highscores.HighscoreEngine.log("Load ( " + nick.highscores.HighscoreEngine.__scorePath + "?msg=Q&game=" + nick.highscores.HighscoreEngine.__game_id + " )");
      nick.highscores.HighscoreEngine.__score_vars = new LoadVars();
      nick.highscores.HighscoreEngine.__score_vars.onLoad = function(success)
      {
         nick.highscores.HighscoreEngine.onHighscores(success);
      };
      nick.highscores.HighscoreEngine.__score_vars.load(nick.highscores.HighscoreEngine.__scorePath + "?msg=Q&game=" + nick.highscores.HighscoreEngine.__game_id);
   }
   static function onHighscores(success)
   {
      nick.highscores.HighscoreEngine.log("Server callback recieved: ");
      nick.highscores.HighscoreEngine.log("Success: " + success);
      nick.highscores.HighscoreEngine.log("Returning game ID: " + nick.highscores.HighscoreEngine.__score_vars.game);
      if(!success || nick.highscores.HighscoreEngine.__score_vars.game != nick.highscores.HighscoreEngine.__game_id)
      {
         nick.highscores.HighscoreEngine.log("Highscore retrieval Failed.");
         nick.highscores.HighscoreEngine.__highscoreMC.showError();
         return undefined;
      }
      nick.highscores.HighscoreEngine.__scores = [];
      var _loc1_ = 0;
      while(_loc1_ < nick.highscores.HighscoreEngine.__score_vars.count)
      {
         nick.highscores.HighscoreEngine.__scores.push({name:nick.highscores.HighscoreEngine.__score_vars["pn" + _loc1_],score:nick.highscores.HighscoreEngine.__score_vars["ps" + _loc1_]});
         _loc1_ = _loc1_ + 1;
      }
      nick.highscores.HighscoreEngine.populateHighscoreBoard();
   }
   static function set userPath(path)
   {
      nick.highscores.HighscoreEngine.__userPath = path;
   }
   static function get userPath()
   {
      return nick.highscores.HighscoreEngine.__userPath;
   }
   static function set scorePath(path)
   {
      nick.highscores.HighscoreEngine.__scorePath = path;
   }
   static function get scorePath()
   {
      return nick.highscores.HighscoreEngine.__scorePath;
   }
   static function set gameID(id)
   {
      nick.highscores.HighscoreEngine.__game_id = id;
   }
   static function get gameID()
   {
      return nick.highscores.HighscoreEngine.__game_id;
   }
   static function get scores()
   {
      return nick.highscores.HighscoreEngine.__scores;
   }
   static function get userName()
   {
      return nick.highscores.HighscoreEngine.__userName;
   }
   static function get isLoggedIn()
   {
      return !(nick.highscores.HighscoreEngine.__userName == undefined || nick.highscores.HighscoreEngine.__userName == "null") ? true : false;
   }
   static function log(message)
   {
      var _loc1_ = new LocalConnection();
      _loc1_.send("_SILCtrace","trace",message);
      _loc1_.close();
      trace("LOG : " + message);
   }
}
