class nick.yugopoMaze.Engine extends smashing.keithm.BaseEngine
{
   var activeWorld;
   var __UI;
   var __interval;
   var __sounds;
   var viewport_mc;
   var __state;
   var isPaused;
   var mouse;
   var mouseHD_mc;
   var key;
   var owner;
   var __gameStartTime;
   var __STARTLEVEL = 0;
   var __WENDYS_CODE = "pappy";
   function Engine()
   {
      super();
   }
   function init()
   {
      super.init();
      this.activeWorld = new nick.yugopoMaze.World();
      this.activeWorld.init(this);
      nick.highscores.HighscoreEngine.init();
      this.pause();
      this.__UI.goScreen("splash");
   }
   function __initInterval()
   {
      this.__interval = new smashing.keithm.IntervalEngine(this,"update");
      this.__interval.startFast();
   }
   function __initSounds()
   {
      nick.yugopoMaze.Sounds.init();
      this.__sounds = nick.yugopoMaze.Sounds.getInstance();
      this.__sounds.generateSounds(this.viewport_mc);
   }
   function __initGameState()
   {
      nick.yugopoMaze.GameState.init();
      this.__state = nick.yugopoMaze.GameState.getInstance();
      this.__state.hasWendysCode = false;
   }
   function __initUI()
   {
      nick.yugopoMaze.ui.UI.init();
      this.__UI = nick.yugopoMaze.ui.UI.getInstance();
      this.__UI.linkEngine(this);
      this.__UI.reset();
   }
   function __initViewport()
   {
      smashing.keithm.Viewport.init(this.viewport_mc,2,nick.yugopoMaze.GameState.getInstance());
      var _loc2_ = smashing.keithm.Viewport.getInstance();
      _loc2_.setScrollport(1);
      _loc2_.createGroup({name:"bg",index:0,slots:20,scrollport:true});
      _loc2_.createGroup({name:"edge",index:1,slots:20,scrollport:true});
      _loc2_.createGroup({name:"patch",index:2,slots:20});
      _loc2_.createGroup({name:"map",index:3,slots:1,scrollport:true});
      _loc2_.createGroup({name:"pickup",index:4,slots:100});
      _loc2_.createGroup({name:"effect",index:5,slots:100,sortAxis:"",reverse:false});
      _loc2_.createGroup({name:"dynamic",index:6,slots:100,sortAxis:"y",ascending:true});
      _loc2_.reset();
   }
   function viewHighscore()
   {
      this.__UI.goScreen("viewHighscore");
   }
   function sendHighscore()
   {
      this.__UI.goScreen("sendHighscore");
   }
   function update(dt)
   {
      if(!this.isPaused)
      {
         this.activeWorld.update(dt);
      }
      this.__UI.update(dt);
      this.__state.hasChanged = false;
      updateAfterEvent();
   }
   function startGame()
   {
      this.__state.reset();
      this.startLevel();
   }
   function startLevel()
   {
      this.__UI.goScreen("gameplay");
      trace("Start Music!");
      this.__state.resetLevel();
      this.__sounds.playMusic();
      this.activeWorld.generate(new nick.yugopoMaze.levels.LevelRandom());
      smashing.keithm.Viewport.getInstance().newView();
      this.activeWorld.start();
      this.unpause();
   }
   function endLevel(success)
   {
      this.pause();
      this.__state.addTimeScore();
      this.__state.levelNum = this.__state.levelNum + 1;
      this.__UI.goScreen("levelTrans");
      this.__sounds.stopMusic();
   }
   function endGame()
   {
      this.pause();
      this.clear();
      this.__sounds.stopMusic();
      this.__UI.goScreen("splash");
   }
   function clear()
   {
      this.activeWorld.clear();
      smashing.keithm.Viewport.getInstance().newView();
   }
   function toggleMusic()
   {
      this.__sounds.toggleMusic();
      smashing.keithm.Messenger.sendMessage("screen","updateMuteButton",{isMuted:this.__sounds.muteMusic});
   }
   function submitWendysCode(t_data)
   {
      if(t_data.code.toLowerCase() == this.__WENDYS_CODE.toLowerCase())
      {
         this.__state.hasWendysCode = true;
         this.__UI.goScreen("intro");
         return undefined;
      }
      smashing.keithm.Messenger.sendMessage("screen","showError");
   }
   function showWendys()
   {
      this.pause();
      this.__UI.goScreen("wendys");
   }
   function showHelp()
   {
      this.pause();
      this.__UI.goScreen("help");
   }
   function hideHelp()
   {
      this.unpause();
      this.__UI.returnToPreviousScreen();
   }
   function winGame()
   {
      trace("Win Game");
      this.pause();
      this.gotoAndStop("end");
   }
   function gameOver()
   {
      this.pause();
      smashing.keithm.Messenger.sendMessage("ui","goScreenRemote",{screen:"gameover"});
   }
   function __initMouse()
   {
   }
   function __clearMouse()
   {
      Mouse.removeListener(this.mouse);
   }
   function mouse_up()
   {
      if(!this.isPaused)
      {
         if(this.mouseHD_mc.hitTest(this._xmouse,this._ymouse))
         {
            this.activeWorld.setTargetPoint(this._xmouse,this._ymouse);
         }
      }
   }
   function __initKey()
   {
      this.key = {};
      this.key.owner = this;
      this.key.onKeyDown = function()
      {
         this.owner.key_down();
      };
      this.key.onKeyUp = function()
      {
         this.owner.key_up();
      };
      Key.addListener(this.key);
   }
   function __clearKey()
   {
      Key.removeListener(this.key);
   }
   function key_down()
   {
      if(Key.getCode() == 32)
      {
         this.activeWorld.usePowerup();
      }
      else if(Key.getCode() > 36 && Key.getCode() < 41)
      {
         this.activeWorld.onMoveKeyPress(Key.getCode());
      }
   }
   function key_up()
   {
      var _loc2_ = Key.getCode();
      if(_loc2_ != 32)
      {
         if(_loc2_ > 36 && _loc2_ < 41)
         {
            this.activeWorld.onMoveKeyRelease(_loc2_);
         }
      }
   }
   function get gameStartTime()
   {
      return this.__gameStartTime;
   }
}
