class nick.yugopoMaze.GameState
{
   var score;
   var lives;
   var levelNum;
   var hasFlower;
   var hasBear;
   var hasChoco;
   var hasChanged;
   var timeRemaining;
   var totalTime;
   var hasKey;
   var __pauseTimer;
   var __ringsPlayed;
   static var __instance;
   var __BASE_TIME = 110;
   var __MIN_TIME = 35;
   var SCREEN_WIDTH = Stage.width;
   var SCREEN_HEIGHT = Stage.height;
   var HALF_WIDTH = Stage.width / 2;
   var HALF_HEIGHT = Stage.height / 2;
   var CELL_WIDTH = 58;
   var CELL_HEIGHT = 58;
   var CELL_WIDTH_HALF = nick.yugopoMaze.GameState.prototype.CELL_WIDTH / 2;
   var CELL_HEIGHT_HALF = nick.yugopoMaze.GameState.prototype.CELL_HEIGHT / 2;
   var MAP_WIDTH = 15;
   var MAP_HEIGHT = 20;
   var sc = {x:Stage.width / 2,y:Stage.height / 2};
   function GameState()
   {
   }
   static function init()
   {
      nick.yugopoMaze.GameState.__instance = new nick.yugopoMaze.GameState();
   }
   static function getInstance()
   {
      return nick.yugopoMaze.GameState.__instance;
   }
   function reset()
   {
      this.score = 0;
      this.lives = 3;
      this.levelNum = 1;
      this.hasFlower = true;
      this.hasBear = this.hasChoco = false;
      this.hasChanged = true;
   }
   function resetLevel()
   {
      this.timeRemaining = this.totalTime = this.__BASE_TIME - this.levelNum * 5;
      if(this.timeRemaining < this.__MIN_TIME)
      {
         this.timeRemaining = this.totalTime = this.__MIN_TIME;
      }
      this.hasKey = false;
      this.__pauseTimer = false;
      this.__ringsPlayed = 0;
      this.hasChanged = true;
   }
   function pauseTimer()
   {
      this.__pauseTimer = true;
   }
   function updateTime(dt)
   {
      if(this.__pauseTimer)
      {
         return undefined;
      }
      this.timeRemaining -= dt;
      if(this.timeRemaining <= 0)
      {
         smashing.keithm.Messenger.sendMessage("engine","gameOver");
         nick.yugopoMaze.Sounds.getInstance().p("alarm");
      }
      else if(this.timeRemaining < 15)
      {
         if(this.__ringsPlayed == 0)
         {
            nick.yugopoMaze.Sounds.getInstance().p("alarm");
            this.__ringsPlayed = this.__ringsPlayed + 1;
         }
         else if(this.timeRemaining < 10 && this.__ringsPlayed == 1)
         {
            nick.yugopoMaze.Sounds.getInstance().p("alarm");
            this.__ringsPlayed = this.__ringsPlayed + 1;
         }
         else if(this.timeRemaining < 5 && this.__ringsPlayed == 2)
         {
            nick.yugopoMaze.Sounds.getInstance().p("alarm");
            this.__ringsPlayed = this.__ringsPlayed + 1;
         }
      }
   }
   function getTimeRatio()
   {
      return this.timeRemaining / this.totalTime;
   }
   function loseLife()
   {
      this.lives = this.lives - 1;
      if(this.lives <= 0)
      {
         smashing.keithm.Messenger.sendMessage("engine","gameOver");
      }
      this.hasChanged = true;
   }
   function addScore(val)
   {
      this.score += val;
      this.hasChanged = true;
   }
   function addTimeScore()
   {
      this.addScore(Math.floor(this.timeRemaining * 2));
   }
   function addPowerup(type)
   {
      if(type == "teddybear")
      {
         this.hasBear = true;
      }
      else if(type == "flower")
      {
         this.hasFlower = true;
      }
      else
      {
         this.hasChoco = true;
      }
      this.hasChanged = true;
   }
   function hasPowerup(type)
   {
      if(type == "teddybear" && this.hasBear)
      {
         return true;
      }
      if(type == "flower" && this.hasFlower)
      {
         return true;
      }
      if(type == "chocolate" && this.hasChoco)
      {
         return true;
      }
   }
   function usePowerup(type)
   {
      if(type == "teddybear")
      {
         this.hasBear = false;
      }
      else if(type == "flower")
      {
         this.hasFlower = false;
      }
      else
      {
         this.hasChoco = false;
      }
      this.hasChanged = true;
   }
   function get screenWidth()
   {
      return this.SCREEN_WIDTH;
   }
   function get screenHeight()
   {
      return this.SCREEN_HEIGHT;
   }
   function get halfWidth()
   {
      return this.HALF_WIDTH;
   }
   function get halfHeight()
   {
      return this.HALF_HEIGHT;
   }
}
