class nick.yugopoMaze.World
{
   var engine;
   var __state;
   var __targetPoint;
   var __pickupsCollected;
   var __isSpaceDown;
   var __entitys;
   var __effects;
   var __player;
   var __camera;
   var __mapArt;
   var loop;
   var __scenery;
   var __grid;
   var __drawnTiles;
   var loopb;
   var __maxZaps;
   var __totalZaps;
   var __pickupsTotal;
   var __PICKUP_ODDS = 0.2;
   var __ZAP_ODDS = 0.2;
   function World()
   {
   }
   function init(t_engine)
   {
      this.engine = t_engine;
      this.__state = nick.yugopoMaze.GameState.getInstance();
      smashing.keithm.Messenger.registerAddress("world",this);
   }
   function start()
   {
      this.__targetPoint = null;
      this.__pickupsCollected = 0;
      this.__isSpaceDown = false;
   }
   function clear()
   {
      this.__entitys = [];
      this.__effects = [];
   }
   function update(dt)
   {
      if(dt > 0.2)
      {
         dt = 0.2;
      }
      this.__player.update(dt);
      if(this.__player.hasChangedCells())
      {
         this.runGridHD(dt,this.__player);
      }
      this.__camera.update(dt,this.__player);
      this.__mapArt.render(this.__camera,dt);
      this.loop = this.__entitys.length;
      var _loc2_ = undefined;
      while(this.loop--)
      {
         _loc2_ = this.__entitys[this.loop];
         if(_loc2_.doUpdate)
         {
            _loc2_.update(dt);
            if(_loc2_.isDrawn && _loc2_.isAlive)
            {
               if(this.__player.runHD(_loc2_,dt))
               {
                  _loc2_.hitReact(this.__player);
                  this.__player.hitReact(_loc2_);
               }
            }
            if(_loc2_.doRemove)
            {
               this.__entitys.splice(this.loop,1);
            }
            else
            {
               _loc2_.render(this.__camera,dt);
            }
         }
      }
      this.__player.moveAndRender(this.__camera,dt);
      if(this.__targetPoint != null)
      {
         this.__targetPoint.render(this.__camera,dt);
      }
      this.loop = this.__scenery.length;
      while(this.loop--)
      {
         this.__scenery[this.loop].updateMoveAndRender(this.__camera,dt);
      }
      this.loop = this.__effects.length;
      while(this.loop--)
      {
         _loc2_ = this.__effects[this.loop];
         if(!_loc2_.isAlive)
         {
            this.__effects.splice(this.loop,1);
         }
         _loc2_.updateMoveAndRender(this.__camera,dt);
      }
      this.__state.updateTime(dt);
   }
   function drawTargetPoint(t_x, t_y)
   {
      if(this.__targetPoint != null)
      {
         this.clearTargetPoint();
      }
      this.__targetPoint = new nick.yugopoMaze.ents.Effect({x:t_x,y:t_y,asset:"moveTarget_mc",owner:this,camera:this.__camera});
      this.__targetPoint.spawn();
   }
   function clearTargetPoint()
   {
      this.__targetPoint.requestErase();
      this.__targetPoint = null;
   }
   function setTargetPoint(t_x, t_y)
   {
      this.__player.setTargetPoint(this.__camera.left + t_x,this.__camera.top + t_y);
   }
   function runGridHD(el, entity)
   {
      if(entity.nextCellY() == 0 || entity.nextCellY() == this.__grid[0].length - 1)
      {
         entity.onGridCollision(el);
         return undefined;
      }
      if(!this.__grid[entity.nextCellX()][entity.nextCellY()].canPass(entity))
      {
         entity.onGridCollision(el);
      }
   }
   function generate(ldata)
   {
      ldata.loadData();
      this.__camera = new nick.yugopoMaze.GameCamera({x:ldata.camera.x,y:ldata.camera.y,dimensions:nick.yugopoMaze.GameState.getInstance()});
      this.__camera.setBounds(0,ldata.grid_width * nick.yugopoMaze.GameState.getInstance().CELL_WIDTH,0,ldata.grid_height * nick.yugopoMaze.GameState.getInstance().CELL_HEIGHT);
      ldata.player.owner = this;
      ldata.player.camera = this.__camera;
      this.__player = new nick.yugopoMaze.ents.Player(ldata.player);
      this.__drawnTiles = [];
      this.__grid = [];
      this.loop = ldata.grid_width;
      while(this.loop--)
      {
         this.__grid[this.loop] = [];
         this.loopb = ldata.grid_height;
         while(this.loopb--)
         {
            this.__grid[this.loop][this.loopb] = new nick.yugopoMaze.cells.Cell({x:this.loop,y:this.loopb,owner:this});
         }
      }
      var _loc2_ = ldata.walls.length;
      while(true)
      {
         _loc2_;
         if(!_loc2_--)
         {
            break;
         }
         ldata.walls[_loc2_].owner = this;
         this.__grid[ldata.walls[_loc2_].x][ldata.walls[_loc2_].y] = new nick.yugopoMaze.cells.Wall(ldata.walls[_loc2_]);
      }
      this.__mapArt = new nick.yugopoMaze.cells.MapArt({grid:this.__grid,x:0,y:0,owner:this,camera:this.__camera});
      this.__entitys = [];
      this.__maxZaps = 3 + Math.floor(this.__state.levelNum * 0.3);
      this.__totalZaps = 0;
      this.generatePickupsAndSpecials();
      _loc2_ = ldata.aliens.length;
      while(true)
      {
         _loc2_;
         if(!_loc2_--)
         {
            break;
         }
         ldata.aliens[_loc2_].owner = this;
         ldata.aliens[_loc2_].camera = this.__camera;
         this.__entitys.push(new nick.yugopoMaze.ents.Alien(ldata.aliens[_loc2_]));
      }
      this.__scenery = [];
      _loc2_ = ldata.scenery.length;
      while(true)
      {
         _loc2_;
         if(!_loc2_--)
         {
            break;
         }
         ldata.scenery[_loc2_].owner = this;
         ldata.scenery[_loc2_].camera = this.__camera;
         if(ldata.scenery[_loc2_].type == "ground")
         {
            this.__scenery.push(new nick.yugopoMaze.ents.Scenery(ldata.scenery[_loc2_]));
         }
         else if(ldata.scenery[_loc2_].type == "edge")
         {
            this.__scenery.push(new nick.yugopoMaze.ents.Scenery_Edge(ldata.scenery[_loc2_]));
         }
         else
         {
            this.__scenery.push(new nick.yugopoMaze.ents.Scenery_Patch(ldata.scenery[_loc2_]));
         }
      }
      this.__effects = [];
   }
   function onMoveKeyPress(code)
   {
      this.__player.onMoveKeyPress(code);
   }
   function onMoveKeyRelease(code)
   {
      this.__player.onMoveKeyRelease(code);
   }
   function generatePickupsAndSpecials()
   {
      var _loc4_ = [];
      var _loc3_ = [];
      var _loc10_ = [];
      var _loc5_ = [];
      var _loc11_ = [];
      var _loc2_ = undefined;
      this.loop = this.__grid.length;
      while(this.loop--)
      {
         this.loopb = this.__grid[this.loop].length;
         while(this.loopb--)
         {
            _loc2_ = 0;
            if(this.__grid[this.loop][this.loopb - 1].TYPE == "wall")
            {
               _loc2_ = _loc2_ + 1;
            }
            if(this.__grid[this.loop][this.loopb + 1].TYPE == "wall")
            {
               _loc2_ = _loc2_ + 1;
            }
            if(this.__grid[this.loop - 1][this.loopb].TYPE == "wall" || this.loop - 1 == -1)
            {
               _loc2_ = _loc2_ + 1;
            }
            if(this.__grid[this.loop + 1][this.loopb].TYPE == "wall" || this.loop + 1 == this.__grid.length)
            {
               _loc2_ = _loc2_ + 1;
            }
            if(this.__grid[this.loop][this.loopb].TYPE == "wall")
            {
               if(_loc2_ == 3 && this.loopb != 0 && this.loopb != 19)
               {
                  _loc11_.push(this.__grid[this.loop][this.loopb]);
               }
               if(_loc2_ == 4)
               {
                  _loc5_.push(this.__grid[this.loop][this.loopb]);
               }
            }
            else if(_loc2_ == 2)
            {
               if(this.__grid[this.loop - 1][this.loopb].TYPE == "wall" && this.__grid[this.loop + 1][this.loopb].TYPE == "wall" || this.__grid[this.loop][this.loopb - 1].TYPE == "wall" && this.__grid[this.loop][this.loopb + 1].TYPE == "wall")
               {
                  _loc10_.push(this.__grid[this.loop][this.loopb]);
               }
               else
               {
                  _loc3_.push(this.__grid[this.loop][this.loopb]);
               }
            }
            else if(_loc2_ == 3 && this.loopb < nick.yugopoMaze.GameState.getInstance().MAP_HEIGHT - 1)
            {
               _loc4_.push(this.__grid[this.loop][this.loopb]);
            }
         }
      }
      this.__pickupsTotal = 0;
      var _loc7_ = false;
      var _loc8_ = false;
      var _loc9_ = !nick.yugopoMaze.GameState.getInstance().hasWendysCode ? true : false;
      var _loc6_ = Math.random() <= 0.5 ? false : true;
      if((this.__state.hasBear && this.__state.hasChoco && this.__state.hasFlower) == false)
      {
         _loc6_ = false;
      }
      this.loop = _loc4_.length;
      while(this.loop--)
      {
         if(!_loc7_)
         {
            this.generateExit(_loc4_[this.loop]);
            _loc7_ = true;
         }
         else if(!_loc8_)
         {
            this.generateKey(_loc4_[this.loop]);
            _loc8_ = true;
         }
         else if(!_loc9_)
         {
            this.generateWendys(_loc4_[this.loop]);
            _loc9_ = true;
         }
         else if(!_loc6_)
         {
            this.generatePowerup(_loc4_[this.loop]);
            _loc6_ = true;
         }
         else
         {
            this.generatePickup(_loc4_[this.loop]);
         }
      }
      this.loop = _loc3_.length;
      while(this.loop--)
      {
         if(!_loc7_)
         {
            this.generateExit(_loc3_[this.loop]);
            _loc7_ = true;
         }
         else if(!_loc8_)
         {
            this.generateKey(_loc3_[this.loop]);
            _loc8_ = true;
         }
         else if(!_loc9_)
         {
            this.generateWendys(_loc3_[this.loop]);
            _loc9_ = true;
         }
         else if(!_loc6_)
         {
            this.generatePowerup(_loc3_[this.loop]);
            _loc6_ = true;
         }
         else
         {
            this.generatePickup(_loc3_[this.loop],true);
         }
      }
      this.loop = _loc10_.length;
      while(this.loop--)
      {
         this.generatePickupOrZapTile(_loc10_[this.loop]);
      }
      this.generateSpaceWindows(_loc11_);
      this.loop = _loc5_.length;
      while(this.loop--)
      {
         _loc5_[this.loop].assetID += "_closed";
      }
      _loc5_ = [];
      _loc3_ = [];
      _loc4_ = [];
   }
   function generatePickup(tile, force)
   {
      if((force == true || Math.random() <= this.__PICKUP_ODDS) && this.__pickupsTotal <= this.__state.levelNum * 3)
      {
         this.__pickupsTotal = this.__pickupsTotal + 1;
         this.__entitys.push(new nick.yugopoMaze.ents.Pickup({x:tile.x,y:tile.y,owner:this,camera:this.__camera}));
         return true;
      }
      return false;
   }
   function generatePickupOrZapTile(tile)
   {
      if(!this.generatePickup(tile))
      {
         if(tile.y < 19 && this.__totalZaps < this.__maxZaps && Math.random() <= this.__ZAP_ODDS)
         {
            if(Math.ceil(this.__state.levelNum / 5) % 2 == 1)
            {
               this.__entitys.push(new nick.yugopoMaze.ents.ZapTile({x:tile.x,y:tile.y,owner:this,camera:this.__camera}));
            }
            else
            {
               this.__entitys.push(new nick.yugopoMaze.ents.TrapTile({x:tile.x,y:tile.y,owner:this,camera:this.__camera}));
            }
            this.__totalZaps = this.__totalZaps + 1;
         }
      }
   }
   function generatePowerup(tile)
   {
      this.__entitys.push(new nick.yugopoMaze.ents.Powerup({x:tile.x,y:tile.y,owner:this,camera:this.__camera}));
   }
   function generateKey(tile)
   {
      this.__entitys.push(new nick.yugopoMaze.ents.BlastKey({x:tile.x,y:tile.y,owner:this,camera:this.__camera}));
   }
   function generateWendys(tile)
   {
      this.__entitys.push(new nick.yugopoMaze.ents.WendysPickup({x:tile.x,y:tile.y,owner:this,camera:this.__camera}));
   }
   function generateExit(tile)
   {
      this.__entitys.push(new nick.yugopoMaze.ents.Exit({x:tile.x,y:tile.y,owner:this,camera:this.__camera}));
   }
   function generateSpaceWindows(fringeWalls)
   {
      var _loc5_ = 1 + (Math.random() <= 0.22 ? 0 : 1);
      var _loc6_ = 10;
      var _loc7_ = undefined;
      var _loc2_ = undefined;
      var _loc4_ = undefined;
      var _loc3_ = [];
      while(_loc5_ > 0 && _loc6_ > 0)
      {
         _loc7_ = Math.floor(Math.random() * (fringeWalls.length - 1));
         _loc2_ = fringeWalls[_loc7_];
         _loc4_ = this.__grid[_loc2_.x - 1][_loc2_.y];
         if(!this.testSpaceWindowUsedSpaces(_loc3_,_loc2_.x - 1,_loc2_.y) && !this.testSpaceWindowUsedSpaces(_loc3_,_loc2_.x,_loc2_.y) && !this.testSpaceWindowUsedSpaces(_loc3_,_loc2_.x - 1,_loc2_.y + 1) && !this.testSpaceWindowUsedSpaces(_loc3_,_loc2_.x,_loc2_.y + 1))
         {
            if(_loc4_.TYPE == "wall" && this.__grid[_loc2_.x][_loc2_.y + 1].TYPE == "wall" && this.__grid[_loc2_.x - 1][_loc2_.y + 1].TYPE == "wall")
            {
               _loc3_.push({x:_loc2_.x,y:_loc2_.y});
               _loc3_.push({x:_loc2_.x - 1,y:_loc2_.y});
               _loc3_.push({x:_loc2_.x - 1,y:_loc2_.y + 1});
               _loc3_.push({x:_loc2_.x,y:_loc2_.y + 1});
               _loc5_ = _loc5_ - 1;
               this.__entitys.push(new nick.yugopoMaze.ents.SpaceWindow({x:_loc4_.x,y:_loc4_.y,owner:this,camera:this.__camera}));
            }
         }
         _loc6_ = _loc6_ - 1;
      }
   }
   function testSpaceWindowUsedSpaces(array, x, y)
   {
      var _loc1_ = array.length;
      while(true)
      {
         _loc1_;
         if(!_loc1_--)
         {
            break;
         }
         if(array[_loc1_].x == x && array[_loc1_].y == y)
         {
            return true;
         }
      }
      return false;
   }
   function addScore(val)
   {
      this.__state.addScore(val);
   }
   function collectPickup()
   {
      this.__pickupsCollected = this.__pickupsCollected + 1;
   }
   function hasCollectedPickups()
   {
      if(this.__pickupsTotal == 0)
      {
         return true;
      }
      return this.__pickupsCollected / this.__pickupsTotal != 1 ? false : true;
   }
   function getPickupsRemaining()
   {
      return this.__pickupsTotal - this.__pickupsCollected;
   }
   function clickPowerup(t_data)
   {
      trace("CLICK! " + t_data.type);
      this.usePowerup(t_data.type);
   }
   function usePowerup(t_type)
   {
      if(!this.__player.canUsePowerup())
      {
         return undefined;
      }
      if(t_type != undefined)
      {
         if(this.__state.hasPowerup(t_type))
         {
            this.__player.usePowerup(t_type);
            this.__state.usePowerup(t_type);
         }
      }
      else if(this.__state.hasFlower)
      {
         this.__player.usePowerup("flower");
         this.__state.usePowerup("flower");
      }
      else if(this.__state.hasChoco)
      {
         this.__player.usePowerup("chocolate");
         this.__state.usePowerup("chocolate");
      }
      else if(this.__state.hasBear)
      {
         this.__player.usePowerup("teddybear");
         this.__state.usePowerup("teddybear");
      }
   }
   function onWendysPickup()
   {
      var _loc2_ = Math.random();
      if(_loc2_ < 0.39)
      {
         smashing.keithm.Messenger.sendMessage("screen","showWendysEffect",{effect:"speed"});
         this.onWendysSpeed();
      }
      else if(_loc2_ < 0.79)
      {
         smashing.keithm.Messenger.sendMessage("screen","showWendysEffect",{effect:"ghost"});
         this.onWendysGhost();
      }
      else
      {
         smashing.keithm.Messenger.sendMessage("screen","showWendysEffect",{effect:"nuke"});
         this.onWendysNuke();
      }
   }
   function onWendysSpeed()
   {
      trace("SPEED");
      this.__player.applyWendysSpeed();
   }
   function onWendysGhost()
   {
      trace("GHOST!");
      this.__player.applyWendysGhost();
   }
   function onWendysNuke()
   {
      trace("NUKE!");
      var _loc3_ = this.__entitys.length;
      var _loc2_ = undefined;
      while(true)
      {
         _loc3_;
         if(!_loc3_--)
         {
            break;
         }
         _loc2_ = this.__entitys[_loc3_];
         if(_loc2_.TYPE == "alien" && _loc2_.isDrawn)
         {
            _loc2_.startDie();
         }
      }
   }
   function onMessageReceived(message, args)
   {
      this[message](args);
   }
}
