class nick.yugopoMaze.ents.Alien extends nick.yugopoMaze.ents.Entity
{
   var startY;
   var __cellY;
   var __pathWidth;
   var __pathHeight;
   var __pathAnchor;
   var __pathLeftX;
   var startX;
   var __pathRightX;
   var __pathCenterX;
   var __pathTopY;
   var __pathBottomY;
   var __crossOnRight;
   var __doCrossMiddle;
   var __headedRight;
   var __movingX;
   var __headedUp;
   var __moveRate;
   var __isAnimating;
   var nextX;
   var x;
   var nextY;
   var y;
   var owner;
   var doRemove;
   var hdReg;
   var TYPE = "alien";
   var DRAWTYPE = "dynamic";
   var __DEF_WIDTH = 50;
   var __DEF_HEIGHT = 90;
   var __USE_ACTUAL_DIMENSIONS = true;
   var __DEF_HD_WIDTH = 40;
   var __DEF_HD_HEIGHT = 49;
   var __USE_DIMENSIONS_AS_HD = false;
   var __DEF_ASSET = "alien_main";
   var __MOVE_RATE_MULT = 5;
   var __MOVE_RATE_BASE = 60;
   var __MOVE_RATE_MAX = 130;
   var value = 100;
   var __USES_VELOCITY = false;
   function Alien(t_data)
   {
      super(t_data);
   }
   function init(t_data)
   {
      super.init(t_data);
      var _loc3_ = nick.yugopoMaze.GameState.getInstance();
      this.startY = this.__cellY * _loc3_.CELL_HEIGHT + _loc3_.CELL_HEIGHT * 0.75;
      this.__pathWidth = (t_data.pathWidth - 1) * _loc3_.CELL_WIDTH;
      this.__pathHeight = (t_data.pathHeight - 1) * _loc3_.CELL_HEIGHT;
      this.__pathAnchor = t_data.pathAnchor * _loc3_.CELL_WIDTH;
      this.__pathLeftX = this.startX - this.__pathAnchor;
      this.__pathRightX = this.__pathLeftX + this.__pathWidth;
      this.__pathCenterX = this.__pathLeftX + this.__pathWidth / 2;
      this.__pathTopY = this.startY - this.__pathHeight;
      this.__pathBottomY = this.startY;
      if(this.__pathTopY < _loc3_.CELL_HEIGHT)
      {
         this.__pathTopY = _loc3_.CELL_HEIGHT + _loc3_.CELL_HEIGHT * 0.75;
      }
      this.__crossOnRight = true;
      if(this.__pathHeight > 0)
      {
         this.__doCrossMiddle = Math.random() >= 0.45 ? false : true;
      }
      else
      {
         this.__doCrossMiddle = false;
      }
      this.__headedRight = Math.random() <= 0.5 ? false : true;
      this.__movingX = this.__headedUp = true;
      if(!this.__headedRight)
      {
         this.flip();
      }
      this.__moveRate = this.__MOVE_RATE_BASE + this.__MOVE_RATE_MULT * _loc3_.levelNum;
      if(this.__moveRate > this.__MOVE_RATE_MAX)
      {
         this.__moveRate = this.__MOVE_RATE_MAX;
      }
      this.spawn();
   }
   function update(dt)
   {
      if(!this.__isAnimating)
      {
         if(this.__movingX)
         {
            if(this.__headedRight)
            {
               this.nextX = this.x + this.__moveRate * dt;
               if(this.nextX > this.__pathRightX)
               {
                  this.nextX = this.__pathRightX;
                  this.__headedRight = false;
                  this.flip();
                  this.toggleMovingAxis();
               }
               else if(this.__doCrossMiddle && this.__crossOnRight && this.nextX > this.__pathCenterX)
               {
                  this.nextX = this.__pathCenterX;
                  this.__crossOnRight = false;
                  this.toggleMovingAxis();
               }
            }
            else
            {
               this.nextX = this.x - this.__moveRate * dt;
               if(this.nextX < this.__pathLeftX)
               {
                  this.nextX = this.__pathLeftX;
                  this.__headedRight = true;
                  this.unflip();
                  this.toggleMovingAxis();
               }
               else if(this.__doCrossMiddle && !this.__crossOnRight && this.nextX < this.__pathCenterX)
               {
                  this.nextX = this.__pathCenterX;
                  this.__crossOnRight = true;
                  this.toggleMovingAxis();
               }
            }
         }
         else if(this.__headedUp)
         {
            this.nextY = this.y - this.__moveRate * dt;
            if(this.nextY < this.__pathTopY)
            {
               this.nextY = this.__pathTopY;
               this.__headedUp = false;
               this.toggleMovingAxis();
            }
         }
         else
         {
            this.nextY = this.y + this.__moveRate * dt;
            if(this.nextY > this.__pathBottomY)
            {
               this.nextY = this.__pathBottomY;
               this.__headedUp = true;
               this.toggleMovingAxis();
            }
         }
      }
      super.update();
   }
   function toggleMovingAxis()
   {
      if(this.__pathHeight > 0 && this.__movingX == true)
      {
         this.__movingX = false;
      }
      else
      {
         this.__movingX = true;
         this.requestDepthChange();
      }
   }
   function render(cam, dt)
   {
      this.x = this.nextX;
      this.y = this.nextY;
      super.render(cam,dt);
   }
   function hitReact(obj)
   {
      if(obj.isUsingPowerup())
      {
         this.owner.addScore(this.value);
         this.startDie();
      }
      else
      {
         this.animate("catch");
      }
   }
   function endDie()
   {
      super.endDie();
      this.doRemove = true;
   }
   function setHDRegistration()
   {
      this.hdReg = {};
      this.hdReg.x = 0;
      this.hdReg.y = -15;
   }
}
