class nick.yugopoMaze.ents.Entity extends smashing.keithm.Renderable
{
   var __cellX;
   var __cellY;
   var startVelocity;
   var doRemove;
   var velocity;
   var __animation;
   var nextX;
   var x;
   var nextY;
   var y;
   var nextZ;
   var z;
   var isAlive;
   var mc;
   var __isAnimating;
   var specialDepth;
   var __3D_SCALE = false;
   var __USE_GRAVITY = true;
   var __DO_UPDATE = true;
   var HAS_SPECIAL_DEPTH = false;
   var __MAX_VELOCITY = 300;
   var __USES_VELOCITY = true;
   var __IDLE_ANIMATION = "idle";
   var __DEATH_ANIMATION = "die";
   function Entity(t_data)
   {
      super(t_data);
   }
   function init(t_data)
   {
      this.__cellX = t_data.x;
      this.__cellY = t_data.y;
      if(t_data.vel != undefined)
      {
         this.startVelocity = t_data.vel;
      }
      else
      {
         this.startVelocity = new smashing.Point3D(0,0,0);
      }
      var _loc4_ = nick.yugopoMaze.GameState.getInstance();
      t_data.x = this.__cellX * _loc4_.CELL_WIDTH + _loc4_.CELL_WIDTH_HALF;
      t_data.y = this.__cellY * _loc4_.CELL_HEIGHT + _loc4_.CELL_HEIGHT_HALF;
      super.init(t_data);
      this.doRemove = false;
      this.spawn();
   }
   function reset()
   {
      this.velocity = this.startVelocity.copy();
      super.reset();
      this.__animation = this.__IDLE_ANIMATION;
   }
   function runHD(t_target, dt)
   {
      return this.runHD_entity_box(t_target,dt);
   }
   function hitReact(t_source)
   {
   }
   function onDraw(t_newmc)
   {
      super.onDraw(t_newmc);
      this.animateLoop(this.__IDLE_ANIMATION);
   }
   function cellX()
   {
      return this.__cellX;
   }
   function cellY()
   {
      return this.__cellY;
   }
   function update(dt)
   {
      this.updateAnim();
      if(this.__USES_VELOCITY)
      {
         this.nextX = this.x + this.velocity.x * dt;
         this.nextY = this.y + this.velocity.y * dt;
         this.nextZ = this.z + this.velocity.z * dt;
      }
   }
   function move(dt)
   {
      if(this.__USES_VELOCITY)
      {
         this.x += this.velocity.x * dt;
         this.y += this.velocity.y * dt;
         this.z += this.velocity.z * dt;
      }
   }
   function moveAndRender(camera, dt)
   {
      if(this.__USES_VELOCITY)
      {
         this.nextX = this.x += this.velocity.x * dt;
         this.nextY = this.y += this.velocity.y * dt;
         this.nextZ = this.z += this.velocity.z * dt;
      }
      this.render(camera,dt);
   }
   function updateMoveAndRender(camera, dt)
   {
      this.updateAnim();
      if(this.__USES_VELOCITY)
      {
         this.nextX = this.x += this.velocity.x * dt;
         this.nextY = this.y += this.velocity.y * dt;
         this.nextZ = this.z += this.velocity.z * dt;
      }
      this.render(camera,dt);
   }
   function onErase()
   {
      super.onErase();
   }
   function takeDamage(power)
   {
      this.startDie();
   }
   function startDie()
   {
      this.kill();
      this.animate(this.__DEATH_ANIMATION);
      if(this.__USES_VELOCITY)
      {
         this.velocity.x = this.velocity.y = 0;
      }
   }
   function endDie()
   {
      this.requestErase();
   }
   function updateDraw(camera)
   {
      if(this.doRemove || !this.isAlive)
      {
         return undefined;
      }
      super.updateDraw(camera);
   }
   function animate(frame)
   {
      if(frame != undefined)
      {
         this.__animation = frame;
      }
      this.mc.gotoAndStop(this.__animation);
      if(this.__animation == this.__IDLE_ANIMATION)
      {
         this.__isAnimating = false;
      }
      else
      {
         this.__isAnimating = true;
      }
   }
   function animateLoop(frame)
   {
      if(frame != undefined)
      {
         this.__animation = frame;
      }
      this.mc.gotoAndStop(this.__animation);
      this.__isAnimating = false;
   }
   function updateAnim()
   {
      if(this.__isAnimating)
      {
         if(this.mc.anim._currentFrame == this.mc.anim._totalFrames)
         {
            if(this.__animation == this.__DEATH_ANIMATION)
            {
               this.endDie();
            }
            else
            {
               this.animateLoop(this.__IDLE_ANIMATION);
            }
         }
      }
   }
   function getDrawType()
   {
      return this.HAS_SPECIAL_DEPTH != true ? this.DRAWTYPE : this.DRAWTYPE + "_" + this.specialDepth;
   }
   function getIsAnimating()
   {
      return this.__isAnimating;
   }
   function isPathing()
   {
      return false;
   }
}
