class nick.yugopoMaze.ents.MoveableEntity extends nick.yugopoMaze.ents.Entity
{
   var __nextCellX;
   var __cellX;
   var __nextCellY;
   var __cellY;
   var __hasChangedCells;
   var __cell_width;
   var __cell_height;
   var __is_pathing;
   var __pathing_dir;
   var __pathing_progress;
   var __targetX;
   var __targetY;
   var __originX;
   var __originY;
   var nextX;
   var nextY;
   var prevY;
   var y;
   var x;
   var __pathing_length;
   var velocity;
   var __MOVE_RATE = 110;
   var __PATHING_THRESHOLD = 5;
   function MoveableEntity(t_data)
   {
      super(t_data);
   }
   function init(t_data)
   {
      super.init(t_data);
      this.__nextCellX = this.__cellX;
      this.__nextCellY = this.__cellY;
      this.__hasChangedCells = false;
      this.__cell_width = nick.yugopoMaze.GameState.getInstance().CELL_WIDTH;
      this.__cell_height = nick.yugopoMaze.GameState.getInstance().CELL_HEIGHT;
      this.__is_pathing = false;
      this.__pathing_dir = "";
      this.__pathing_progress = 0;
      this.__targetX = this.__targetY = this.__originX = this.__originY = -1;
   }
   function update(el)
   {
      super.update(el);
      this.__nextCellX = Math.floor(this.nextX / this.__cell_width);
      this.__nextCellY = Math.floor(this.nextY / this.__cell_height);
      if(this.__cellX != this.__nextCellX || this.__cellY != this.__nextCellY)
      {
         this.__hasChangedCells = true;
      }
      else
      {
         this.__hasChangedCells = false;
      }
   }
   function move(el)
   {
      if(this.__hasChangedCells)
      {
         this.__cellX = this.__nextCellX;
         this.__cellY = this.__nextCellY;
      }
      super.move(el);
   }
   function moveAndRender(camera, el)
   {
      if(this.__hasChangedCells)
      {
         this.__cellX = this.__nextCellX;
         this.__cellY = this.__nextCellY;
      }
      this.prevY = this.y;
      super.moveAndRender(camera,el);
      this.requestDepthChange();
      if(this.__is_pathing)
      {
         if(this.__pathing_dir == "x")
         {
            this.__pathing_progress = 1 - Math.abs(this.x - this.__targetX) / this.__pathing_length;
         }
         else
         {
            this.__pathing_progress = 1 - Math.abs(this.y - this.__targetY) / this.__pathing_length;
         }
      }
   }
   function onGridCollision()
   {
      this.__pathing_collision();
      if(this.__cellX != this.__nextCellX)
      {
         this.velocity.x = 0;
         this.__nextCellX = this.__cellX;
      }
      if(this.__cellY != this.__nextCellY)
      {
         this.velocity.y = 0;
         this.__nextCellY = this.__cellY;
      }
      return true;
   }
   function __pathing_start(targetx, targety)
   {
      this.__originX = this.x;
      this.__originY = this.y;
      this.__targetX = targetx;
      this.__targetY = targety;
      if(this.__originX == this.__targetX)
      {
         this.__pathing_dir = "y";
         this.__pathing_length = Math.abs(this.__originY - this.__targetY);
      }
      else
      {
         this.__pathing_dir = "x";
         this.__pathing_length = Math.abs(this.__originX - this.__targetX);
      }
      this.__pathing_progress = 0;
      this.__is_pathing = true;
   }
   function __pathing_run()
   {
      if(this.__pathing_dir == "x")
      {
         if(this.__targetX < this.x - this.__PATHING_THRESHOLD)
         {
            this.velocity.x = - this.__MOVE_RATE;
         }
         else if(this.__targetX > this.x + this.__PATHING_THRESHOLD)
         {
            this.velocity.x = this.__MOVE_RATE;
         }
         else
         {
            this.__pathing_stop();
         }
      }
      else if(this.__targetY < this.y - this.__PATHING_THRESHOLD)
      {
         this.velocity.y = - this.__MOVE_RATE;
      }
      else if(this.__targetY > this.y + this.__PATHING_THRESHOLD)
      {
         this.velocity.y = this.__MOVE_RATE;
      }
      else
      {
         this.__pathing_stop();
      }
   }
   function __pathing_collision()
   {
      if(this.__pathing_dir == "x")
      {
         this.__targetX = this.__originX;
      }
      else
      {
         this.__targetY = this.__originY;
      }
   }
   function __pathing_stop()
   {
      this.velocity.x = this.velocity.y = 0;
      this.__targetX = this.__targetY = this.__originX = this.__originY = -1;
      this.__is_pathing = false;
      this.__pathing_dir = "";
   }
   function hasChangedCells()
   {
      return this.__hasChangedCells;
   }
   function nextCellX()
   {
      return this.__nextCellX;
   }
   function nextCellY()
   {
      return this.__nextCellY;
   }
   function isPathing()
   {
      return this.__is_pathing;
   }
}
