class nick.yugopoMaze.ents.Player extends nick.yugopoMaze.ents.MoveableEntity
{
   var __event;
   var __direction;
   var __hasMovedTimer;
   var __hasKey;
   var __moveCode;
   var __wendysTimer;
   var __walkRate;
   var __prevAnimation;
   var __animation;
   var __prevDirection;
   var velocity;
   var __hasPowerup;
   var __powerupTimer;
   var __hasPowerupLowAlarmPlayed;
   var __isSpeeded;
   var __moveable;
   var __is_pathing;
   var __isAnimating;
   var mc;
   var __powerupType;
   var isAlive;
   var nextX;
   var x;
   var nextY;
   var y;
   var __isInvincible;
   var __isGhosted;
   var owner;
   var __cellX;
   var __nextCellX;
   var __cellY;
   var __nextCellY;
   var __targetX;
   var __targetY;
   var __targetCellX;
   var __cell_width;
   var __targetCellY;
   var __cell_height;
   var __pathing_dir;
   var __collisionCellX;
   var __collisionCellY;
   var hdReg;
   var TYPE = "player";
   var DRAWTYPE = "dynamic";
   var __DEF_ASSET = "timmy_main";
   var __DEF_WIDTH = 40;
   var __DEF_HEIGHT = 60;
   var __USE_ACTUAL_DIMENSIONS = true;
   var __DEF_HD_WIDTH = 20;
   var __DEF_HD_HEIGHT = 10;
   var __USE_DIMENSIONS_AS_HD = false;
   var __WALK_RATE = 185;
   var __SPEEDWALK_RATE = 320;
   var __IDLE_ANIMATION = "stand";
   var __POWERUP_TIMER_MAX = 9;
   var __PATHING_THRESHOLD = 5;
   var __HAS_MOVED_TIMER = 15;
   function Player(t_data)
   {
      super(t_data);
   }
   function init(t_data)
   {
      super.init(t_data);
      this.__event = "";
      this.__direction = "right";
      this.__pathing_stop();
      this.__hasMovedTimer = this.__HAS_MOVED_TIMER;
      this.__hasKey = false;
      this.__moveCode = 0;
      this.__wendysTimer = 0;
      this.__walkRate = this.__WALK_RATE;
   }
   function updateDraw(camera)
   {
      super.updateDraw(camera);
   }
   function onMoveKeyPress(code)
   {
      this.__moveCode = code;
   }
   function onMoveKeyRelease(code)
   {
      if(this.__moveCode == code)
      {
         this.__moveCode = 0;
      }
   }
   function update(dt)
   {
      this.__prevAnimation = this.__animation;
      this.__prevDirection = this.__direction;
      this.velocity.x = 0;
      this.velocity.y = 0;
      if(this.__hasPowerup)
      {
         this.__powerupTimer -= dt;
         if(this.__powerupTimer <= 1 && !this.__hasPowerupLowAlarmPlayed)
         {
            nick.yugopoMaze.Sounds.getInstance().p("powerup_off");
            this.__hasPowerupLowAlarmPlayed = true;
         }
         else if(this.__powerupTimer <= 0)
         {
            this.finishPowerup();
            this.animate();
         }
      }
      if(this.__wendysTimer > 0)
      {
         this.__wendysTimer -= dt;
         if(this.__wendysTimer <= 0)
         {
            if(this.__isSpeeded)
            {
               this.resolveWendysSpeed();
            }
            else
            {
               this.resolveWendysGhost();
            }
         }
      }
      if(this.__moveable)
      {
         this.__animation = "walk";
         if(this.__moveCode == 37)
         {
            this.velocity.x = - this.__walkRate;
            this.__direction = "left";
         }
         else if(this.__moveCode == 39)
         {
            this.velocity.x = this.__walkRate;
            this.__direction = "right";
         }
         else if(this.__moveCode == 38)
         {
            this.velocity.y = - this.__walkRate;
            this.__direction = "up";
         }
         else if(this.__moveCode == 40)
         {
            this.velocity.y = this.__walkRate;
            this.__direction = "down";
         }
         else
         {
            this.__animation = "stand";
         }
      }
      if(this.__is_pathing)
      {
         if(this.velocity.x == 0 && this.velocity.y == 0)
         {
            this.__pathing_run();
         }
         else
         {
            this.__pathing_stop();
         }
      }
      if(this.__event != "")
      {
         this.runEvent();
      }
      if(!this.__isAnimating && this.__animation != this.__prevAnimation || this.__direction != this.__prevDirection)
      {
         this.animate();
      }
      super.update(dt);
   }
   function animate(frame)
   {
      if(frame != undefined)
      {
         this.__animation = frame;
      }
      if(this.__animation == "walk")
      {
         this.mc.gotoAndStop(this.__animation + "_" + this.__direction + (!this.__hasPowerup ? "" : "_item"));
         if(this.__hasPowerup)
         {
            this.mc.a.torso_mc.item.gotoAndStop(this.__powerupType);
         }
         this.__isAnimating = false;
      }
      else if(this.__animation == "stand")
      {
         this.mc.gotoAndStop(this.__animation + "_" + this.__direction);
         if(!this.__hasPowerup)
         {
            this.mc.a.item._visible = false;
         }
         else
         {
            this.mc.a.item._visible = true;
            this.mc.a.item.gotoAndStop(this.__powerupType);
         }
         this.__isAnimating = false;
      }
      else
      {
         this.mc.gotoAndStop(this.__animation);
         this.__isAnimating = true;
      }
   }
   function animateLoop(frame)
   {
      this.animate(frame);
   }
   function updateAnim()
   {
      if(this.__isAnimating)
      {
         if(this.mc.a._currentFrame == this.mc.a._totalFrames)
         {
            if(!this.isAlive)
            {
               this.endDie();
            }
            else if(this.__animation == "blast")
            {
               smashing.keithm.Messenger.sendMessage("engine","endLevel");
            }
            else
            {
               this.animate(this.__IDLE_ANIMATION);
            }
         }
      }
   }
   function block(entity)
   {
      if(this.nextX != this.x)
      {
         this.velocity.x = 0;
      }
      if(this.nextY != this.y)
      {
         this.velocity.y = 0;
      }
      if(this.__is_pathing)
      {
         this.__pathing_stop();
      }
   }
   function reset()
   {
      this.finishPowerup();
      this.unfreeze();
      this.__isInvincible = false;
      super.reset();
   }
   function freeze()
   {
      this.__moveable = false;
   }
   function unfreeze()
   {
      this.__moveable = true;
   }
   function runHD(t_target, dt)
   {
      if(!this.isAlive)
      {
         return false;
      }
      return super.runHD(t_target,dt);
   }
   function freezeAnimation()
   {
      this.animate("stand");
   }
   function hitReact(obj)
   {
      if(obj.TYPE == "alien")
      {
         if(this.__hasPowerup || this.__isInvincible)
         {
            return undefined;
         }
         this.startDie("die");
      }
      else if(obj.TYPE == "zaptile")
      {
         if(!obj.isZapping() || this.__isGhosted)
         {
            return undefined;
         }
         this.startDie("zap");
      }
      else if(obj.TYPE == "traptile")
      {
         if(!obj.isZapping() || this.__isGhosted)
         {
            return undefined;
         }
         this.x = this.nextX = obj.x;
         this.y = this.nextY = obj.y;
         this.startDie("fall");
      }
      else if(obj.TYPE == "key")
      {
         this.__hasKey = true;
         smashing.keithm.Messenger.sendMessage("screen","chargeKey");
      }
      else if(obj.TYPE == "exit")
      {
         if(!this.__moveable)
         {
            return undefined;
         }
         if(this.owner.hasCollectedPickups() == false)
         {
            smashing.keithm.Messenger.sendMessage("screen","showInsufficientPickups",{needed:this.owner.getPickupsRemaining()});
            return undefined;
         }
         if(!this.__hasKey)
         {
            smashing.keithm.Messenger.sendMessage("screen","showMissingKey");
            return undefined;
         }
         this.resolveWendysSpeed();
         this.resolveWendysGhost();
         this.setTargetPoint(obj.x,obj.y);
         this.__event = "exit";
         this.__isInvincible = true;
         this.freeze();
      }
   }
   function startDie(anim)
   {
      this.freeze();
      this.kill();
      this.animate(anim);
      if(this.__USES_VELOCITY)
      {
         this.velocity.x = this.velocity.y = 0;
      }
   }
   function endDie()
   {
      nick.yugopoMaze.GameState.getInstance().loseLife();
      if(nick.yugopoMaze.GameState.getInstance().lives > 0)
      {
         this.reset();
         this.requestDepthChange();
      }
   }
   function usePowerup(t_type)
   {
      this.__powerupType = t_type;
      this.__hasPowerup = true;
      this.__powerupTimer = this.__POWERUP_TIMER_MAX;
      nick.yugopoMaze.Sounds.getInstance().p("pickup_" + t_type);
      this.animate();
   }
   function finishPowerup()
   {
      this.__hasPowerup = false;
      this.__hasPowerupLowAlarmPlayed = false;
      this.__powerupType = "";
   }
   function isUsingPowerup()
   {
      return this.__hasPowerup;
   }
   function canUsePowerup()
   {
      return !(this.__hasPowerup || this.__isInvincible || this.__hasPowerup || !this.__moveable);
   }
   function applyWendysSpeed()
   {
      this.__isSpeeded = true;
      this.__wendysTimer = 9;
      this.__walkRate = this.__SPEEDWALK_RATE;
   }
   function applyWendysGhost()
   {
      this.__isGhosted = true;
      this.__isInvincible = true;
      this.__wendysTimer = 7;
      this.mc._alpha = 60;
   }
   function resolveWendysSpeed()
   {
      if(!this.__isSpeeded)
      {
         return undefined;
      }
      this.__isSpeeded = false;
      this.__walkRate = this.__WALK_RATE;
      this.__wendysTimer = 0;
   }
   function resolveWendysGhost()
   {
      if(!this.__isGhosted)
      {
         return undefined;
      }
      this.__isGhosted = false;
      this.__isInvincible = false;
      this.__wendysTimer = 0;
      this.mc._alpha = 100;
   }
   function runEvent()
   {
      if(this.__event == "exit")
      {
         if(!this.__is_pathing)
         {
            this.__event = "";
            this.animate("blast");
            nick.yugopoMaze.GameState.getInstance().pauseTimer();
         }
      }
   }
   function onGridCollision(el)
   {
      if(this.__is_pathing)
      {
         this.__pathing_collision();
      }
      if(this.__cellX != this.__nextCellX)
      {
         this.velocity.x = 0;
         this.__nextCellX = this.__cellX;
      }
      if(this.__cellY != this.__nextCellY)
      {
         this.velocity.y = 0;
         this.__nextCellY = this.__cellY;
      }
      super.update(el);
      return true;
   }
   function setTargetPoint(t_x, t_y)
   {
      this.__targetX = t_x;
      this.__targetY = t_y;
      this.__targetCellX = Math.floor(this.__targetX / this.__cell_width);
      this.__targetCellY = Math.floor(this.__targetY / this.__cell_height);
      this.__pathing_chooseDirection();
      this.__hasMovedTimer = 0;
   }
   function __pathing_chooseDirection()
   {
      var _loc3_ = this.__targetX - this.x;
      var _loc2_ = this.__targetY - this.y;
      this.__is_pathing = true;
      if(Math.abs(_loc3_) > Math.abs(_loc2_) + this.__PATHING_THRESHOLD)
      {
         this.__pathing_dir = "x";
      }
      else if(Math.abs(_loc3_) < Math.abs(_loc2_) - this.__PATHING_THRESHOLD)
      {
         this.__pathing_dir = "y";
      }
      else
      {
         this.__pathing_stop();
      }
   }
   function __pathing_run()
   {
      this.__animation = "walk";
      if(this.__pathing_dir == "x")
      {
         if(this.__targetX < this.x - this.__PATHING_THRESHOLD)
         {
            this.velocity.x = - this.__walkRate;
            this.__direction = "left";
         }
         else if(this.__targetX > this.x + this.__PATHING_THRESHOLD)
         {
            this.velocity.x = this.__walkRate;
            this.__direction = "right";
         }
         else
         {
            this.__pathing_chooseDirection();
         }
      }
      else if(this.__targetY < this.y - this.__PATHING_THRESHOLD)
      {
         this.velocity.y = - this.__walkRate;
         this.__direction = "up";
      }
      else if(this.__targetY > this.y + this.__PATHING_THRESHOLD)
      {
         this.velocity.y = this.__walkRate;
         this.__direction = "down";
      }
      else
      {
         this.__pathing_chooseDirection();
      }
   }
   function __pathing_collision()
   {
      if(this.__pathing_dir == "x")
      {
         if(this.__collisionCellX == this.__cellX)
         {
            this.__pathing_stop();
         }
         else
         {
            this.__collisionCellX = this.__cellX;
            this.__pathing_dir = "y";
         }
      }
      else if(this.__collisionCellY == this.__cellY)
      {
         this.__pathing_stop();
      }
      else
      {
         this.__collisionCellY = this.__cellY;
         this.__pathing_dir = "x";
      }
   }
   function __pathing_stop()
   {
      this.owner.clearTargetPoint();
      this.__targetCellX = this.__targetCellY = this.__collisionCellX = this.__collisionCellY = this.__targetX = this.__targetY = -1;
      this.__is_pathing = false;
      this.__pathing_dir = "";
   }
   function setHDRegistration()
   {
      this.hdReg = {};
      this.hdReg.x = 0;
      this.hdReg.y = 0;
   }
   function direction()
   {
      return this.__direction;
   }
   function isFrozen()
   {
      return !this.__moveable;
   }
}
