class nick.yugopoMaze.ui.UI
{
   var engine;
   var __nextScreenID;
   var __hasActiveScreen;
   var __doesActiveScreenUpdate;
   var __activeScreen;
   var __previousScreenID;
   var __activeScreenID;
   static var __instance;
   function UI()
   {
   }
   static function init()
   {
      nick.yugopoMaze.ui.UI.__instance = new nick.yugopoMaze.ui.UI();
   }
   static function getInstance()
   {
      return nick.yugopoMaze.ui.UI.__instance;
   }
   function linkEngine(t_engine)
   {
      this.engine = t_engine;
      smashing.keithm.Messenger.registerAddress("ui",this);
   }
   function reset()
   {
      this.__nextScreenID = "";
      this.__hasActiveScreen = false;
      this.__doesActiveScreenUpdate = false;
   }
   function update(dt)
   {
      if(this.__doesActiveScreenUpdate)
      {
         this.__activeScreen.update(dt);
      }
   }
   function returnToPreviousScreen()
   {
      this.__nextScreenID = this.__previousScreenID;
      this.__activeScreen.close();
   }
   function goScreen(id)
   {
      if(this.__hasActiveScreen)
      {
         this.__nextScreenID = id;
         this.__activeScreen.close(!(this.__nextScreenID == "help" || this.__nextScreenID == "wendys") ? false : true);
      }
      else
      {
         this.openScreen(id);
      }
   }
   function openScreen(id)
   {
      trace("Ok... open screen " + id);
      if(id == undefined)
      {
         id = this.__nextScreenID;
      }
      if(id == "")
      {
         return undefined;
      }
      this.__nextScreenID = "";
      this.__previousScreenID = this.__activeScreenID;
      this.__activeScreenID = id;
      this.engine.gotoAndStop(this.__activeScreenID);
      switch(this.__activeScreenID)
      {
         case "splash":
            this.__activeScreen = new nick.yugopoMaze.ui.Splash(this.engine.screen_mc,this);
            break;
         case "gameplay":
            this.__activeScreen = new nick.yugopoMaze.ui.GamePlay(this.engine.screen_mc,this,this.__previousScreenID != "help" ? false : true);
            break;
         case "help":
            this.__activeScreen = new nick.yugopoMaze.ui.Help(this.engine.screen_mc,this,this.__previousScreenID != "splash" ? false : true);
            break;
         case "wendys":
            this.__activeScreen = new nick.yugopoMaze.ui.Wendys(this.engine.screen_mc,this);
            break;
         case "levelTrans":
            this.__activeScreen = new nick.yugopoMaze.ui.LevelTrans(this.engine.screen_mc,this);
            break;
         case "intro":
            this.__activeScreen = new nick.yugopoMaze.ui.Intro(this.engine.screen_mc,this);
            break;
         case "gameover":
            this.__activeScreen = new nick.yugopoMaze.ui.GameOver(this.engine.screen_mc,this);
            break;
         case "viewHighscore":
            this.__activeScreen = new nick.yugopoMaze.ui.Highscores(this.engine.screen_mc,this,true);
            break;
         case "sendHighscore":
            this.__activeScreen = new nick.yugopoMaze.ui.Highscores(this.engine.screen_mc,this,false);
            break;
         default:
            trace("[UI] openScreen called with invalid id: " + this.__activeScreenID);
            return undefined;
      }
      this.__activeScreen.init();
      this.__activeScreen.open();
      smashing.keithm.Messenger.registerAddress("screen",this.__activeScreen);
      this.__hasActiveScreen = true;
      this.__doesActiveScreenUpdate = this.__activeScreen.DOES_UPDATE;
   }
   function onScreenClosed()
   {
      if(this.__nextScreenID != "")
      {
         this.openScreen(this.__nextScreenID);
      }
   }
   function goScreenRemote(t_data)
   {
      trace("GO screen : " + t_data.screen);
      if(t_data.screen == undefined)
      {
         trace("Error: Go screen remote requires data format {screen:string}");
         return undefined;
      }
      this.goScreen(t_data.screen);
   }
   function onMessageReceived(message, args)
   {
      this[message](args);
   }
   function get currentScreenID()
   {
      return this.__activeScreenID;
   }
}
